#! /bin/bash

WWW_DIR='SOME_WWW_DIR'

FW=$1
PRIVATE_KEY=$2
SHA_FILE=$FW.sha1
XML_FILE=$FW.xml
OWNER="OWNER"

openssl dgst -sha1 -sign $PRIVATE_KEY -out $SHA_FILE $FW

DATE=`echo $FW | tr '_' "\n" | sed -n 2p`
VERSION=`echo $FW | tr '_' "\n" | sed -n 3p`

rm -f $WWW_DIR/* 2> /dev/null

echo -n "\
<?xml version=\"1.0\" encoding=\"UTF-8\" ?>
<keys>
<key>
<owner>$OWNER</owner>
<filename>keys/pub.key.pem</filename>
</key>
</keys>" > $WWW_DIR/keys.xml

echo -n "\
<?xml version=\"1.0\" encoding=\"UTF-8\" ?>
<firmware>
<version>$VERSION</version>
<date>$DATE</date>
<image>$FW</image>
<signatures>
<signature>
<publisher>$OWNER</publisher>
<filename>$SHA_FILE</filename>
</signature>
</signatures>
</firmware>" > $WWW_DIR/$XML_FILE

mv $SHA_FILE $WWW_DIR/$SHA_FILE
cp -f $FW $WWW_DIR/$FW

echo -n $FW > $WWW_DIR/current
